import java.util.*;

public class consulting {
	static int[] s;
	static int[] r;
	static int[] d;
	static int[] memo;
	static final int oo = 987654321;
	
	/*
	 This problem can be solved with a bitmask dp.
	 The bitmask represents which employees have already been convinced
	 and the dp returns the minimum amount of mental energy required to convince
	 the employees not yet in the bitmask
	 
	 */
	
	public static void main(String[] args)  {
		
		Scanner in = new Scanner(System.in);
		
		int n  = in.nextInt();
		s = new int[n];
		r = new int[n];
		d = new int[n];
		for (int i = 0; i < s.length; i++) {
			s[i] = in.nextInt();
			r[i] = in.nextInt();
			d[i] = in.nextInt();
		}
		
		memo = new int[1<<n];
		for(int i =0;i < memo.length; i++){
			memo[i]= -1;
		}
		
		System.out.println(dp(0));
		
		in.close();
	}
	
	static int dp(int bm){
		if(bm == (1<<s.length)-1) return 0; //If the bitmask is full, we are done and we won't need anymore mental energy
		if(memo[bm] != -1) return memo[bm];
		
		int best = oo;
		for(int i = 0; i < s.length; i++){
			if((1<<i & bm) == 0 && (i == 0 || (1<<s[i] & bm) != 0)){
				//If we have not convinced employee i and we have convinced his supervisor
				
				int possibleBest = Math.max(r[i], d[i]+dp(bm^(1<<i)));
				/*
				 	We call the dp on the bitmask with the employee i bit turned on.
				 	This dp call will return the minimum amount of energy to convince the
				 	remaining employees, and after Mulch is drained on employee i he must have at least that amount.
				 	Additionally Mulch must also meet the requirement for employee i.
				 	
				 */
				best = Math.min(best, possibleBest); //We want the minimum over all choices.
			}
		}
		
		return memo[bm] = best;
		
	}

}
