
import java.util.*;
import java.io.*;

public class consulting_font
{
   public static void main(String[] args) throws Exception
   {
      PrintWriter out = new PrintWriter(System.out);
      new consulting_font(new FastScanner(System.in), out);
      out.close();
   }

   int N, oo = 987654321;
   int[] par, req, cost, dp;
   boolean canSatisfy(int initialBudget)
   {
      Arrays.fill(dp, -oo);
      dp[0] = initialBudget;

      for (int mask=0; mask<(1<<N); mask++)
      {
         if (dp[mask] < 0) continue;
      
         for (int i=0; i<N; i++)
         {
            if (par[i] == -1 || ((1<<par[i])&mask) > 0)
            {
               if (dp[mask] >= req[i])
               {
                  int nmask = mask | (1<<i);
                  dp[nmask] = Math.max(dp[nmask], dp[mask]-cost[i]);
               }
            }
         }
      }

      return dp[(1<<N)-1] >= 0;   
   }

   public consulting_font(FastScanner in, PrintWriter out)
   {
      N = in.nextInt();

      par = new int[N];
      req = new int[N];
      cost = new int[N];
      dp = new int[1 << N];
      for (int i=0; i<N; i++)
      {
         par[i] = in.nextInt();
         req[i] = in.nextInt();
         cost[i] = in.nextInt();
      }

      int lo = 0, hi = 20_000;
      while (lo < hi)
      {
         int m = (lo+hi)/2;
         if (canSatisfy(m))
            hi = m;
         else
            lo = m+1;
      }

      out.println(hi);
   }
}

class FastScanner{
   private InputStream stream;
   private byte[] buf = new byte[1024];
   private int curChar;
   private int numChars;

   public FastScanner(InputStream stream)
   {
      this.stream = stream;
   }

   int read()
   {
      if (numChars == -1)
         throw new InputMismatchException();
      if (curChar >= numChars){
         curChar = 0;
         try{
            numChars = stream.read(buf);
         } catch (IOException e) {
            throw new InputMismatchException();
         }
         if (numChars <= 0)
            return -1;
      }
      return buf[curChar++];
   }

   boolean isSpaceChar(int c)
   {
      return c==' '||c=='\n'||c=='\r'||c=='\t'||c==-1;
   }
   
   boolean isEndline(int c)
   {
      return c=='\n'||c=='\r'||c==-1;
   }

   int nextInt()
   {
      return Integer.parseInt(next());
   }
   
   long nextLong()
   {
      return Long.parseLong(next());
   }

   double nextDouble()
   {
      return Double.parseDouble(next());
   }

   String next(){
      int c = read();
      while (isSpaceChar(c))
         c = read();
      StringBuilder res = new StringBuilder();
      do{
         res.appendCodePoint(c);
         c = read();
      }while(!isSpaceChar(c));
      return res.toString();
   }
   
   String nextLine(){
      int c = read();
      while (isEndline(c))
         c = read();
      StringBuilder res = new StringBuilder();
      do{
         res.appendCodePoint(c);
         c = read();
      }while(!isEndline(c));
      return res.toString();
   }
}
