// Arup Guha
// 7/9/2017
// Solution to SI@UCF Contest #2 Problem: Sorting K Window Sums

import java.util.*;

public class ksums_arup {
	
	public static void main(String[] args) {
		
		Scanner stdin = new Scanner(System.in);
		int n = stdin.nextInt();
		int k = stdin.nextInt();
		
		// Read in our values.
		long[] vals = new long[n];
		for (int i=0; i<n; i++)
			vals[i] = stdin.nextLong();
			
		// Figure out sum of the first window.
		long[] sums = new long[n-k+1];
		for (int i=0; i<k; i++)
			sums[0] += vals[i];
			
		// We can get the next ksum by just adding term i to the old sum and subtracting term i-k.
		for (int i=k; i<n; i++)
			sums[i-k+1] = sums[i-k] + vals[i] - vals[i-k];
			
		// Create objects for custom sort and sort.
		item[] list = new item[n-k+1];
		for (int i=0; i<n-k+1; i++)
			list[i] = new item(sums[i], i+1);
		Arrays.sort(list);
		
		// Output the IDs of the sorted list.
		for (int i=0; i<n-k; i++)
			System.out.print(list[i].ID+" ");
		System.out.println(list[n-k].ID);
	}	
}

class item implements Comparable<item> {
	
	public long value;
	public int ID;
	
	public item(long v, int idnum) {
		value = v;
		ID = idnum;
	}
	
	// Here are our sorting rules.
	public int compareTo(item other) {
		if (this.value < other.value) return 1;
		if (this.value > other.value) return -1;
		return this.ID - other.ID;
	}
}