import java.util.*;
// author: Derek

public class story{
	static class Node{
		long ways;
		int componentSize;
		ArrayList<Node> prevs = new ArrayList<>();
		
		void dfs(){
			// need to solve for all the children first
			for(Node child : prevs){
				child.dfs();
			}
			
			// solve for componentSize
			componentSize = 1;
			for(Node child : prevs){
				componentSize += child.componentSize;
			}
			
			// solve for ways
			ways = 1;
			int nodesCombined = 0;
			for(Node child : prevs){
				
				// put the nodes into the set. do <total nodes> choose <child # of nodes>
				nodesCombined += child.componentSize;
				ways *= pastri[nodesCombined - child.componentSize][child.componentSize];
				ways %= MOD;
				
				// permute the number of ways those nodes can be ordered
				ways *= child.ways;
				ways %= MOD;
			}
		}
	}
	
	static long[][] pastri;
	static long MOD = 1_000_000_007L;
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int N = in.nextInt();
		
		// generate pascal's triangle
		// this really is the most intensive part of the runtime
		pastri = new long[N+1][N+1];
		for(int n = 0; n <= N; n++){
			pastri[0][n] = pastri[n][0] = 1;
		}
		for(int i = 1; i <= N; i++){
			for(int j = 1; j <= N; j++){
				pastri[i][j] = pastri[i][j-1] + pastri[i-1][j];
				pastri[i][j] %= MOD;
			}
		}
		
		// make the tree
		Node[] nodes = new Node[N];
		for(int n = 0; n < N; n++){
			nodes[n] = new Node();
		}
		for(int n = 0; n < N-1; n++){
			int ndex = in.nextInt()-1;
			nodes[ndex].prevs.add(nodes[n]);
		}
		
		// do a DFS
		nodes[N-1].dfs();
		
		// output the answer
		System.out.println(nodes[N-1].ways);
	}
}