// Arup Guha
// 4/22/2014
// Solution to COP 4516 Team Final Contest Problem: Cyber Security Wars
// Edited to handle one case per file for SI@UCF 2017 Contest #2

import java.util.*;

public class war {

	public static void main(String[] args) {

		Scanner stdin = new Scanner(System.in);

		// Set up the graph.
		int n = stdin.nextInt();
		ArrayList[] g = new ArrayList[n];
		for (int i=0; i<n; i++)
			g[i] = new ArrayList<Integer>();

		// Read in the edges.
		int e = stdin.nextInt();
		for (int i=0; i<e; i++) {
			int v1 = stdin.nextInt();
			int v2 = stdin.nextInt();
			g[v1].add(v2);
			g[v2].add(v1);
		}

		// Output result - the last requirement can be checked by maximal vertex degree.
		if (twoColor(g) && maxDeg(g) < n-1)
			System.out.println("YES");
		else
			System.out.println("NO");
	}

	// Returns the maximum degree of any vertex in g.
	public static int maxDeg(ArrayList[] g) {
		int ans = g[0].size();
		for (int i=0; i<g.length; i++)
			if (g[i].size() > ans)
				ans = g[i].size();
		return ans;
	}

	public static boolean twoColor(ArrayList[] g) {

		// Set up palette.
		Color[] settings = new Color[g.length];
		Arrays.fill(settings, Color.UNASSIGNED);

		// Try coloring each node.
		for (int i=0; i<g.length; i++) {
			if (settings[i] == Color.UNASSIGNED) {
				boolean res = dfs(g, settings, i, Color.RED);
				if (!res) return false;
			}
		}

		// If we get here, we colored the whole graph.
		return true;
	}

	public static boolean dfs(ArrayList[] g, Color[] settings, int v, Color cur) {

		// Color this node.
		settings[v] = cur;

		// Go through each neighbor.
		for (int i=0; i<g[v].size(); i++) {

			Color next = settings[(Integer)g[v].get(i)];

			// Found a conflict.
			if (next == cur) return false;

			// Consistent coloring.
			if (next != Color.UNASSIGNED) continue;

			// Color neighbors.
			boolean res = dfs(g, settings, (Integer)g[v].get(i), opposite(cur));
			if (!res) return false;
		}

		// We're good if we made it here.
		return true;
	}

	// c must not be unassigned to call this method.
	public static Color opposite(Color c) {
		if (c == Color.RED)
			return Color.GREEN;
		else
			return Color.RED;
	}
}

enum Color {
	RED, GREEN, UNASSIGNED
}