import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Scanner;

public class war_garrison {
	
	static final int UNASSIGNED = 0, RED = 1, BLUE = 2;

	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		
		int numStudents = scan.nextInt();
		int numEnemyPairs = scan.nextInt();
		
		Vertex[] students = new Vertex[numStudents];
		for (int i = 0; i < numStudents; i++) students[i] = new Vertex(i);
		
		for (int i = 0; i < numEnemyPairs; i++) {
			int a = scan.nextInt(), b = scan.nextInt();
			students[a].enemies.add(b);
			students[b].enemies.add(a);
		}
		
		boolean isPossible = true;
		outerLoop : for (int i = 0; i < numStudents; i++) {
			// We've already assigned this student to a team.
			if (students[i].color != UNASSIGNED) continue;
			
			ArrayDeque<Integer> queue = new ArrayDeque<>();
			queue.add(i);
			students[i].color = RED;
			while (!queue.isEmpty()) {
				int currIdx = queue.poll();
				Vertex curr = students[currIdx];
				int otherColor = otherColor(curr.color);
				
				for (int enemy : curr.enemies) {
					if (curr.color == students[enemy].color) {
						// We're trying to put two enemies on the same team, which is impossible.
						isPossible = false;
						break outerLoop;
					}
					
					if (students[enemy].color == UNASSIGNED) {
						// If we haven't assigned him to a team, do so and add them to the queue.
						students[enemy].color = otherColor;
						queue.add(enemy);
					}
				}
			}
		}
		
		// If any of the students is enemies with every other student, it is impossible to assign teams.
		isPossible &= (maxDegree(students) < numStudents - 1);
		
		System.out.println(isPossible ? "YES" : "NO");
	}
	
	// Checks how many enemies each student has.
	static int maxDegree(Vertex[] graph) {
		int max = 0;
		for (Vertex v : graph) max = Math.max(max, v.enemies.size());
		return max;
	}
	
	static int otherColor(int color) {
		if (color == RED) return BLUE;
		else return RED;
	}

	static class Vertex {
		int idx, color;
		ArrayList<Integer> enemies;
		
		public Vertex(int idx) {
			this.idx = idx;
			this.color = UNASSIGNED;
			this.enemies = new ArrayList<>();
		}
		
	}
}
